glibmm: Gio::DBus::ObjectSkeleton Class Reference

glibmm 2.64.4

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::DBus::ObjectSkeleton Class Reference
D-Bus API

Service-side D-Bus object. More...

`#include <giomm/dbusobjectskeleton.h>`

Inheritance diagram for Gio::DBus::ObjectSkeleton:
[legend]

## Public Member Functions
| ObjectSkeleton (ObjectSkeleton&& src) noexcept
ObjectSkeleton& | operator= (ObjectSkeleton&& src) noexcept
| ~ObjectSkeleton () noexcept override
GDBusObjectSkeleton* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusObjectSkeleton* | gobj () const
| Provides access to the underlying C GObject. More...
GDBusObjectSkeleton* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | flush ()
| This method simply calls g_dbus_interface_skeleton_flush() on all interfaces belonging to object. More...
void | add_interface (const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >& iface)
| Adds iface to object. More...
void | remove_interface (const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >& iface)
| Removes iface from object. More...
void | remove_interface (const Glib::ustring& interface_name)
| Removes the DBusInterface with interface_name from object. More...
void | set_object_path (const Glib::ustring& object_path)
| Sets the object path for object. More...
Glib::PropertyProxy< Glib::ustring > | property_g_object_path ()
| The object path where the object is exported. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_g_object_path () const
| The object path where the object is exported. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >&, const Glib::RefPtr< Gio::DBus::MethodInvocation >& > | signal_authorize_method ()
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::DBus::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
GDBusObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusObject* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_object_path () const
| Gets the object path for object. More...
std::vector< Glib::RefPtr< Gio::DBus::Interface > > | get_interfaces ()
| Gets the D-Bus interfaces associated with object. More...
std::vector< Glib::RefPtr< const Gio::DBus::Interface > > | get_interfaces () const
| Gets the D-Bus interfaces associated with object. More...
Glib::RefPtr< Gio::DBus::Interface > | get_interface (const Glib::ustring& interface_name)
| Gets the D-Bus interface with name interface_name associated with object, if any. More...
Glib::RefPtr< const Gio::DBus::Interface > | get_interface (const Glib::ustring& interface_name) const
| Gets the D-Bus interface with name interface_name associated with object, if any. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Interface >& > | signal_interface_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Interface >& > | signal_interface_removed ()
virtual Glib::ustring | get_object_path_vfunc () const
virtual std::vector< Glib::RefPtr< Gio::DBus::Interface > > | get_interfaces_vfunc () const
virtual Glib::RefPtr< Gio::DBus::Interface > | get_interface_vfunc (const Glib::ustring& interface_name) const
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ObjectSkeleton > | create (const Glib::ustring& object_path)
| Creates a new Gio::DBus::ObjectSkeleton. More...
Static Public Member Functions inherited from Gio::DBus::Object
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| ObjectSkeleton (const Glib::ustring& object_path)
virtual bool | on_authorize_method (const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >& iface, const Glib::RefPtr< Gio::DBus::MethodInvocation >& invocation)
| This is a default handler for the signal signal_authorize_method(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::DBus::Object
| Object ()
| You should derive from this class to use it. More...
virtual void | on_interface_added (const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_added(). More...
virtual void | on_interface_removed (const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_removed(). More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::DBus::ObjectSkeleton > | wrap (GDBusObjectSkeleton* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::DBus::Object
Glib::RefPtr< Gio::DBus::Object > | wrap (GDBusObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Service-side D-Bus object.

A Gio::DBus::ObjectSkeleton instance is essentially a group of D-Bus interfaces. The set of exported interfaces on the object may be dynamic and change at runtime.

This type is intended to be used with Gio::DBus::ObjectManager.

Since glibmm 2.62:

## Constructor & Destructor Documentation

## ◆ ObjectSkeleton() [1/2]

Gio::DBus::ObjectSkeleton::ObjectSkeleton | ( | ObjectSkeleton&& | src | ) |
| noexcept

## ◆ ~ObjectSkeleton()

Gio::DBus::ObjectSkeleton::~ObjectSkeleton | ( |  | ) |
| overridenoexcept

## ◆ ObjectSkeleton() [2/2]

Gio::DBus::ObjectSkeleton::ObjectSkeleton | ( | const Glib::ustring& | object_path | ) |
| explicitprotected

## Member Function Documentation

## ◆ add_interface()

void Gio::DBus::ObjectSkeleton::add_interface | ( | const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >& | iface | ) |

Adds iface to object.

If object already contains a DBusInterfaceSkeleton with the same interface name, it is removed before iface is added.

Note that object takes its own reference on iface and holds it until removed.

Since glibmm 2.30:

Parameters

  iface | A DBusInterfaceSkeleton.

## ◆ create()

static Glib::RefPtr<ObjectSkeleton> Gio::DBus::ObjectSkeleton::create | ( | const Glib::ustring& | object_path | ) |
| static

Creates a new Gio::DBus::ObjectSkeleton.

Parameters

  object_path | An object path.

Returns
  A new Gio::DBus::ObjectSkeleton.

## ◆ flush()

void Gio::DBus::ObjectSkeleton::flush | ( |  | ) |

This method simply calls g_dbus_interface_skeleton_flush() on all interfaces belonging to object.

See that method for when flushing is useful.

Since glibmm 2.30:

## ◆ get_type()

static GType Gio::DBus::ObjectSkeleton::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GDBusObjectSkeleton* Gio::DBus::ObjectSkeleton::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GDBusObjectSkeleton* Gio::DBus::ObjectSkeleton::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GDBusObjectSkeleton* Gio::DBus::ObjectSkeleton::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ on_authorize_method()

virtual bool Gio::DBus::ObjectSkeleton::on_authorize_method | ( | const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >& | iface,
|  | const Glib::RefPtr< Gio::DBus::MethodInvocation >& | invocation
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_authorize_method().

## ◆ operator=()

ObjectSkeleton& Gio::DBus::ObjectSkeleton::operator= | ( | ObjectSkeleton&& | src | ) |
| noexcept

## ◆ property_g_object_path() [1/2]

Glib::PropertyProxy< Glib::ustring > Gio::DBus::ObjectSkeleton::property_g_object_path | ( |  | ) |

The object path where the object is exported.

Since glibmm 2.30:

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_g_object_path() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::DBus::ObjectSkeleton::property_g_object_path | ( |  | ) | const

The object path where the object is exported.

Since glibmm 2.30:

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove_interface() [1/2]

void Gio::DBus::ObjectSkeleton::remove_interface | ( | const Glib::RefPtr< Gio::DBus::InterfaceSkeleton >& | iface | ) |

Removes iface from object.

Since glibmm 2.30:

Parameters

  iface | A DBusInterfaceSkeleton.

## ◆ remove_interface() [2/2]

void Gio::DBus::ObjectSkeleton::remove_interface | ( | const Glib::ustring& | interface_name | ) |

Removes the DBusInterface with interface_name from object.

If no D-Bus interface of the given interface exists, this function does nothing.

Since glibmm 2.30:

Parameters

  interface_name | A D-Bus interface name.

## ◆ set_object_path()

void Gio::DBus::ObjectSkeleton::set_object_path | ( | const Glib::ustring& | object_path | ) |

Sets the object path for object.

Since glibmm 2.30:

Parameters

  object_path | A valid D-Bus object path.

## ◆ signal_authorize_method()

Glib::SignalProxy< bool,const Glib::RefPtr<Gio::DBus::InterfaceSkeleton>&,const Glib::RefPtr<Gio::DBus::MethodInvocation>& > Gio::DBus::ObjectSkeleton::signal_authorize_method | ( |  | ) |

Slot Prototype:
  `bool on_my_authorize_method(const Glib::RefPtr<Gio::DBus::InterfaceSkeleton>& iface, const Glib::RefPtr<Gio::DBus::MethodInvocation>& invocation)`

Flags: Run Last

Emitted when a method is invoked by a remote caller and used to determine if the method call is authorized.

This signal is like DBusInterfaceSkeleton's DBusInterfaceSkeleton::signal_g_authorize_method() signal, except that it is for the enclosing object.

The default class handler just returns `true`.

Since glibmm 2.30:

Parameters

  iface | The DBusInterfaceSkeleton that invocation is for.
  invocation | A DBusMethodInvocation.

Returns
  `true` if the call is authorized, `false` otherwise.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::DBus::ObjectSkeleton > wrap | ( | GDBusObjectSkeleton * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.